#
# spec file for package perl-LWPx-ParanoidAgent
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           perl-LWPx-ParanoidAgent
Version:        1.12
Release:        1.1
%define cpan_name LWPx-ParanoidAgent
Summary:        Subclass of Lwp::Useragent That Protects You From Harm
License:        GPL-1.0+ or Artistic-1.0
Group:          Development/Libraries/Perl
Url:            http://search.cpan.org/dist/LWPx-ParanoidAgent/
Source0:        http://www.cpan.org/authors/id/S/SA/SAXJAZMAN/lwp/%{cpan_name}-%{version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(LWP::UserAgent)
BuildRequires:  perl(Net::DNS)
Requires:       perl(LWP::UserAgent)
Requires:       perl(Net::DNS)
%{perl_requires}

%description
The 'LWPx::ParanoidAgent' is a class subclassing 'LWP::UserAgent', but
paranoid against attackers. It's to be used when you're fetching a remote
resource on behalf of a possibly malicious user.

This class can do whatever 'LWP::UserAgent' can (callbacks, uploads from
files, etc), except proxy support is explicitly removed, because in that
case you should do your paranoia at your proxy.

Also, the schemes are limited to http and https, which are mapped to
'LWPx::Protocol::http_paranoid' and 'LWPx::Protocol::https_paranoid',
respectively, which are forked versions of the same ones without the
"_paranoid". Subclassing them didn't look possible, as they were
essentially just one huge function.

This class protects you from connecting to internal IP ranges (unless you
whitelist them), hostnames/IPs that you blacklist, remote webserver
tarpitting your process (the timeout parameter is changed to be a global
timeout over the entire process), and all combinations of redirects and DNS
tricks to otherwise tarpit and/or connect to internal resources.

%prep
%setup -q -n %{cpan_name}-%{version}
find . -type f ! -name \*.pl -print0 | xargs -0 chmod 644

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%install
%perl_make_install
%perl_process_packlist
%perl_gen_filelist

%files -f %{name}.files
%defattr(-,root,root,755)
%doc ChangeLog README README.md rebuild.sh

%changelog
* Sat Oct  1 2016 coolo@suse.com
- updated to 1.12
  see /usr/share/doc/packages/perl-LWPx-ParanoidAgent/ChangeLog
  1.12    2016-09-29
  - Fix to work with Net::DNS 1.03 (RT#108745)
  Net::DNS::bgsend()/bgread() API changed in a backward-incompatible
  way in 1.03. Deal with either a IO::Select object or a socket, as it
  was before.  (Cosimo Streppone <cosimo@cpan.org>)
  - fixed: https://github.com/csirtgadgets/LWPx-ParanoidAgent/issues/18
  - fixed: https://github.com/csirtgadgets/LWPx-ParanoidAgent/issues/14
  1.11	2014-
  - fixed read-timeout issue: https://github.com/csirtgadgets/LWPx-ParanoidAgent/issues/7
* Mon Apr 13 2015 coolo@suse.com
- updated to 1.10
  see /usr/share/doc/packages/perl-LWPx-ParanoidAgent/ChangeLog
  1.10	2013-11-11
  - fixed: https://github.com/csirtgadgets/LWPx-ParanoidAgent/issues/3
  - fixed: https://github.com/csirtgadgets/LWPx-ParanoidAgent/issues/4
  1.09:       2013-05-02
  - released
  - Makefile.PL updated
  1.08_02:    2013-04-29
  - removed TLS test for now, some cpan testers reporting issues with the configuration, seems pointless given the Makefile
  1.08_01:    2013-04-26
  - removed some of the tests that seem to fail on congested machines (eg: cpantesters).
  1.08:       2013-03-30
  - [SREZIC] added mirror support: https://rt.cpan.org/Ticket/Display.html?id=44569
* Wed Feb 16 2011 lnussel@suse.de
- new package version 1.07
